package ru.dbotthepony.kbox2d.api

/**
 * Delegate of b2World.
 */
interface IContactManager {
	fun addPair(proxyUserDataA: Any?, proxyUserDataB: Any?)

	fun findNewContacts()

	fun destroy(contact: IContact)

	fun collide()

	val broadPhase: IBroadPhase
	var contactList: IContact?

	val contactListIterator: Iterator<IContact> get() {
		return object : Iterator<IContact> {
			private var node = contactList

			override fun hasNext(): Boolean {
				return node != null
			}

			override fun next(): IContact {
				val old = node!!
				node = old.next
				return old
			}
		}
	}

	val contactCount: Int
	var contactFilter: IContactFilter?
	var contactListener: IContactListener?
}
