package ru.dbotthepony.kbox2d.dynamics.contact

import ru.dbotthepony.kbox2d.api.IFixture
import ru.dbotthepony.kbox2d.api.IShape
import ru.dbotthepony.kbox2d.api.Manifold
import ru.dbotthepony.kbox2d.api.Transform
import ru.dbotthepony.kbox2d.collision.handler.b2CollidePolygons
import ru.dbotthepony.kbox2d.collision.shapes.PolygonShape

class PolygonContact(
	fixtureA: IFixture,
	fixtureB: IFixture,
) : AbstractContact(fixtureA, 0, fixtureB, 0) {
	init {
		require(fixtureA.type == IShape.Type.POLYGON) { "Fixture A has type of ${fixtureA.type}" }
		require(fixtureB.type == IShape.Type.POLYGON) { "Fixture B has type of ${fixtureB.type}" }
	}

	override fun evaluate(xfA: Transform, xfB: Transform): Manifold {
		return b2CollidePolygons(
			fixtureA.shape as PolygonShape,
			xfA,
			fixtureB.shape as PolygonShape,
			xfB)
	}
}
